(PackageInfo named: 'acceptit') preamble: 'nil'!
SystemOrganization addCategory: #'acceptit-Core-Compiler'!
SystemOrganization addCategory: #'acceptit-Core-Model'!
SystemOrganization addCategory: #'acceptit-Tests'!
SystemOrganization addCategory: #'acceptit-Tests-Fixtures'!
SystemOrganization addCategory: #'acceptit-Libraries'!
SystemOrganization addCategory: #'acceptit-GUI'!
SystemOrganization addCategory: #'acceptit-Core'!
(PackageInfo named: 'acceptit') postscript: '"below, add code to be run after the loading of this package"
'!

PluggableListMorphPlus subclass: #ACPluggableListMorphPlus
	instanceVariableNames: 'getListItemColorSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

!ACPluggableListMorphPlus methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:57'!
getListItemColorAt: anIndex

	^ getListItemColorSelector 
		ifNotNil: [ self model perform: getListItemColorSelector withArguments: {anIndex}]
		ifNil: [ self halt Color black ]! !

!ACPluggableListMorphPlus methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:43'!
getListItemColorSelector

	^ getListItemColorSelector! !

!ACPluggableListMorphPlus methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:43'!
getListItemColorSelector: aSymbol
	getListItemColorSelector := aSymbol! !

!ACPluggableListMorphPlus methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 02:13'!
listMorphClass
	^ACLazyListMorph! !

LazyListMorph subclass: #ACLazyListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

!ACLazyListMorph methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:54'!
colorForRow: row
	
	^(selectedRow notNil and: [ row = selectedRow])
		ifTrue: [ self class listSelectionTextColor ]
		ifFalse: [ listSource getListItemColorAt: row ].! !

WAComponent subclass: #ACTestRootComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 12:49'!
canBeRoot

^true! !

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 13:01'!
registerApplication

^WAAdmin 
		register: self
		asApplicationAt: 'ACTest'.! !

!ACTestRootComponent methodsFor: 'as yet unclassified' stamp: 'topa 6/23/2010 15:45'!
renderContentOn: html
 "I render everything by calling html"

	html paragraph: 'Hello World'.! !

!ACTestRootComponent methodsFor: 'as yet unclassified' stamp: 'db 6/29/2010 15:27'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Hello World'.! !

PluggableListSpec subclass: #ACPluggableListSpec
	instanceVariableNames: 'getListItemColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

!ACPluggableListSpec methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 03:32'!
buildWith: builder
	^builder buildACPluggableList: self! !

!ACPluggableListSpec methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:39'!
getListItemColor

	^ getListItemColor ! !

!ACPluggableListSpec methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:38'!
getListItemColor: aSymbol
	"Set the selector to get the item color"
	getListItemColor := aSymbol.
	! !

!String methodsFor: '*acceptit' stamp: 'topa 6/16/2010 14:56'!
asCamelCase
	"Convert to CamelCase. Can be conveinient 
	in conjunction with #asLegalSelector 
	'A man, a plan, a canal, panama' asCamelCase.
	'A man, a plan, a canal, panama' asCamelCase asLegalSelector.
	'Here 123should % be 6 the name6 of the method' asCamelCase.
	'Here 123should % be 6 the name6 of the method' asCamelCase asLegalSelector."
	
	^ self class streamContents: [:stream | 
		self substrings do: [:sub |
			stream nextPutAll: sub capitalized]]! !

!String methodsFor: '*acceptit' stamp: 'topa 7/8/2010 15:06'!
withLeadingAuxiliaryNormalized

	({
		{'am'.'are'.'is'} -> 'is'.
		{'have'.'has'} -> 'has'.
		{'shall'. 'should'} -> 'should'.
		{'may'. 'might'} -> 'may'.
		{'will'. 'would'} -> 'will'.
		{'can'.'could'} -> 'can'.
	} as: Dictionary) keysAndValuesDo: [:key :value|
		(self beginsWithAnyOf: key) 
			ifTrue:[^ value, String space, (self copyAfter: Character space)]].
		
	 ^ self! !

!String methodsFor: '*acceptit' stamp: 'topa 7/8/2010 13:54'!
withoutLeadingSubject

	| s |
	s := self withBlanksCondensed.
	^ (s asLowercase beginsWithAnyOf: #( i he she it you we they ))
		ifTrue: [	s copyAfter: Character space]
		ifFalse: [s]! !

Object subclass: #ACAlbatrossLibrary
	instanceVariableNames: 'scenario browser testComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Libraries'!

ACAlbatrossLibrary class
	instanceVariableNames: 'browser'!

ACAlbatrossLibrary class
	instanceVariableNames: 'browser'!

!ACAlbatrossLibrary class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 07:18'!
compilerClass

	^ACLibraryCompiler! !

!ACAlbatrossLibrary class methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 11:25'!
newForScenario: aUserStoryObjectBeeingAScenario

	^ self basicNew
		scenario: aUserStoryObjectBeeingAScenario;
		initialize! !

!ACAlbatrossLibrary class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 12:16'!
parserClass

	^ ACSDParser! !

!ACAlbatrossLibrary class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 12:16'!
shoutParserClass

	^ACSHParserForLibrary! !

!ACAlbatrossLibrary methodsFor: 'accessing' stamp: 'topa 7/14/2010 15:28'!
browser

	^ browser! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:39'!
buildDefaultConfiguration: aDictionary

	aDictionary 
		at: #albatrossSubjectApplication
			put: WAApplication new;
		at: #albatrossPort
			put: 8080! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'fg 7/11/2010 11:36'!
click: aButtonLabel
	
	self browser click: aButtonLabel.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 13:38'!
createTestComponent
	"See comment of #subjectApplication"
	
	^ (self subjectApplication configuration at: #rootClass) new! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:29'!
delay
	
	^ 0.5! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/11/2010 11:30'!
enter: aString for: aLabel
	
	self browser enter: aString for: aLabel.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 13:38'!
getTestComponent
	"I return the root component of the subject application"
	
	^ testComponent ifNil: [
		testComponent := self createTestComponent ]! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 11:26'!
scenario

	^scenario! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 11:26'!
scenario: anObject

	scenario := anObject! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:42'!
setUp
	| handler |	
	
	handler := ARequestHandler default reset; yourself.
	self wrapper port: (self scenario configuration at: #albatrossPort).
	self wrapper initializeWith: self subjectApplication for: self.
	
	browser := handler browser
		applicationUrl: self wrapper applicationUrl 
		driverUrl: self wrapper driverUrl.
	
	browser timeout: self timeout .
	browser responseDelay: self delay.
	browser open.
	browser timeout: self timeout.
	browser receiveOrTimeout.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 11:57'!
subjectApplication

	^ self scenario configuration at: #albatrossSubjectApplication
! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:46'!
tearDown

	self browser end.
	self wrapper port: nil.! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'fg 7/11/2010 11:48'!
textExists: aString

	^self browser textExists: aString.! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'topa 8/31/2010 07:21'!
(then) see :aString

	^self browser textExists: aString withoutQuoting.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 03:59'!
timeout
	^5! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'topa 8/31/2010 07:20'!
(when) click on :aButtonLabel
	
	self browser click: aButtonLabel withoutQuoting.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 07:19'!
(when) enter :aString for :aLabel
	
	self browser enter: aString withoutQuoting for: aLabel withoutQuoting.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:26'!
wrapper

	^ AComponentWrapper! !

Object subclass: #ACVerticalPrototypeLibrary
	instanceVariableNames: 'scenario'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACVerticalPrototypeLibrary class methodsFor: 'as yet unclassified' stamp: 'db 7/9/2010 12:45'!
newForScenario: aUserStoryObjectBeeingAScenario

	^ self basicNew
		scenario: aUserStoryObjectBeeingAScenario;
		initialize! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 15:11'!
givenHasAWebSite

	"see setUp. has to be done there, because albatross expects a 
	running service during setup."! !

!ACVerticalPrototypeLibrary methodsFor: 'accessing' stamp: 'db 7/9/2010 12:47'!
scenario

	^scenario! !

!ACVerticalPrototypeLibrary methodsFor: 'accessing' stamp: 'db 7/9/2010 12:47'!
scenario: anObject

	scenario := anObject! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 15:11'!
setUp

	WASwazooAdaptor startOn: (self scenario configuration at: #albatrossPort). 
	ACTestRootComponent registerApplication.
	(Delay forMilliseconds: 500) wait.
! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 15:12'!
tearDown

	 |adaptor |
		
	WADispatcher default unregister: 'ACTest'.
	adaptor := WAAdmin serverAdaptors detect: [:a | a port = 9999] ifNone: [nil].
	adaptor ifNotNil: [:a|
		a isRunning ifTrue: [ a stop ].
		(Delay forMilliseconds: 250) wait.
		(a isRunning or: [a isStopping]) ifTrue: [a kill]	].! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 09:34'!
thenSeeHelloWorld

	
	^ self scenario browser textExists: 'Hello World'! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 09:40'!
whenGoToTheWebSite

	" this is done by the Albatross lib. No need to implement "! !

MorphicToolBuilder subclass: #ACMorphicToolBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

!ACMorphicToolBuilder class methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 03:06'!
isActiveBuilder
	"Answer whether I am the currently active builder"
	^false! !

!ACMorphicToolBuilder methodsFor: 'as yet unclassified' stamp: 'db 7/24/2010 16:55'!
buildACPluggableList: aSpec
	| widget listClass getIndex setIndex |
	aSpec getSelected ifNil:[
		listClass := ACPluggableListMorphPlus.
		getIndex := aSpec getIndex.
		setIndex := aSpec setIndex.
	] ifNotNil:[
		listClass := self listByItemClass.
		getIndex := aSpec getSelected.
		setIndex := aSpec setSelected.
	].
	widget := listClass on: aSpec model
				list: aSpec list
				selected: getIndex
				changeSelected: setIndex
				menu: aSpec menu
				keystroke: aSpec keyPress.
	self register: widget id: aSpec name.
	widget getListElementSelector: aSpec listItem.
	widget getListItemColorSelector: aSpec getListItemColor.
	widget getListSizeSelector: aSpec listSize.
	widget doubleClickSelector: aSpec doubleClick.
	widget dragItemSelector: aSpec dragItem.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	widget autoDeselect: aSpec autoDeselect.
	widget keystrokePreviewSelector: aSpec keystrokePreview.
	aSpec color isNil ifFalse: [widget color: aSpec color].
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	^widget! !

!ACMorphicToolBuilder methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 03:32'!
pluggableACListSpec
	
	^ ACPluggableListSpec! !

OMeta2 subclass: #ACParser
	instanceVariableNames: 'stParser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 18:05'!
charNoNewline =

	<char:x ?[x ~= Character cr]>! !

!ACParser methodsFor: 'parsing' stamp: 'topa 9/22/2010 10:22'!
endOfLastToken
	" this should only happen after #parseSelector: "
	
	^ stParser endOfLastToken! !

!ACParser methodsFor: 'initialize-release' stamp: 'topa 9/22/2010 10:18'!
initialize

	stParser := self class parserClass new! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 17:51'!
lineEnd =

	<char:x ?[x = Character cr]>! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 14:25'!
parse: sourceStreamOrString class: behavior 
	^ self parse: sourceStreamOrString readStream class: behavior
		noPattern: false context: nil notifying: nil ifFail: [^nil]! !

!ACParser methodsFor: 'public access' stamp: 'topa 9/22/2010 12:03'!
parse: sourceStream class: cls noPattern: pat context: ctx notifying: req ifFail: block 
	^ stParser 
		parse: sourceStream
		class: cls
		noPattern: pat
		context: ctx
		notifying: req
		ifFail: block! !

!ACParser methodsFor: 'parsing' stamp: 'topa 9/22/2010 13:23'!
parseSelector: aStringOrText

	| codeToParse |
	[ | parseTree | 
		parseTree := self class matchStream: aStringOrText asString readStream with: self startRule withArgs: #() withPlaybackDebugging: false.
		codeToParse := ACTranslator match: parseTree with: self startRule.
	] on: OM2Fail do: [:ignore | 
		codeToParse := aStringOrText "fallback. especially for St-classes"].
	^ stParser parseSelector: codeToParse
! !

!ACParser methodsFor: 'shout' stamp: 'topa 6/14/2010 15:02'!
rangesIn: sourceString classOrMetaClass: aBehaviour workspace: aWorkspace  environment: anEnvironmentOrNil

	^ nil! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/20/2010 09:59'!
space =
	// we do not allow newline as whitespace
	
	^space:s ?[ ({Character cr. Character lf} noneSatisfy: [:c | c =s ])]! !

!ACParser methodsFor: 'ometa' stamp: 'topa 9/22/2010 11:22'!
startRule
	" specify the OMeta-rule parsing shall start with "

	self subclassResponsibility! !

ACParser subclass: #ACSDParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACSDParser methodsFor: 'stepDefinition-Rules' stamp: 'topa 9/22/2010 11:19'!
methodBody :sel = 

	<char+>:body -> [{body}]! !

!ACSDParser methodsFor: 'stepDefinition-Rules' stamp: 'topa 9/22/2010 11:19'!
selectorLine =

	selectorTag:t spaces <charNoNewline+>:sel -> [{t. sel}]! !

!ACSDParser methodsFor: 'stepDefinition-Rules' stamp: 'topa 9/22/2010 11:19'!
selectorTag =

	spaces <``(''>  <(``given'' | ``when'' | ``then'')>:tag <``)''> spaces  -> [tag asSymbol]! !

!ACSDParser methodsFor: 'ometa' stamp: 'topa 9/22/2010 11:25'!
startRule

	^ #stepDefinition! !

!ACSDParser methodsFor: 'stepDefinition-Rules' stamp: 'topa 9/22/2010 11:55'!
stepDefinition =

		selectorLine:s lineEnd
		(methodBody(s):b lineEnd?)? end 
			-> [s, b]
		! !

ACParser subclass: #ACUSParser
	instanceVariableNames: 'tempString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
and =

	 spaces <``And''> spaces <charNoNewline+>:body -> [body]! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
applyLines :rule =

	apply(rule):firstBody
	(lineEnd and)*:andBodies -> [{rule . firstBody} , andBodies]
! !

!ACUSParser methodsFor: 'parser emulation' stamp: 'topa 9/22/2010 14:11'!
endOfLastToken

	^ (tempString indexOf: Character cr startingAt: 1)
		min: (tempString indexOf: Character lf startingAt: 1)! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
given =

	 spaces <``Given''> spaces <charNoNewline+>:body -> [body]! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
meansLine =

	spaces <``I want'' `` to''?> spaces <charNoNewline+>:body -> [{#means . body}]! !

!ACUSParser methodsFor: 'parser emulation' stamp: 'topa 9/22/2010 14:09'!
parseSelector: aString

	tempString := aString.
	^ aString lines first! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
purposeLine =

	 spaces <``In order to''> spaces <charNoNewline+>:body -> [{#purpose . body}]! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
roleLine =

		 spaces <``As a'' ``n''?> spaces <charNoNewline+>:body -> [{#role . body}]! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
scenario =

	title:t lineEnd+
	applyLines(#given):given lineEnd
	applyLines(#when):when lineEnd
	applyLines(#then):then lineEnd? end -> [{#scenario. t. given. when. then}]
	! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
scenarioForRunner =

	title:t lineEnd+
	applyLines(#given):given lineEnd
	applyLines(#when):when lineEnd
	applyLines(#then):then lineEnd? end -> [{given. when. then}] 
	! !

!ACUSParser methodsFor: 'ometa' stamp: 'topa 9/22/2010 11:25'!
startRule

	^ #scenario! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
then =

	 spaces <``Then''> spaces <charNoNewline+>:body -> [body]! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
title =

	<charNoNewline+>:body -> [{#title . body}]! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
userStory =
	
	title:t lineEnd+
	purposeLine:purpose lineEnd
	roleLine:role lineEnd
	meansLine:means lineEnd? end -> [{#userStory. t. purpose. role. means}]
	! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
when =

	 spaces <``When''> spaces <charNoNewline+>:body -> [body]! !

OMeta2 subclass: #ACTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:00'!
bindParametersInCollection: aCollection toValuesIn: aString

	|result runString|
	
	result := OrderedCollection new.
	runString := aString.
	1 to: aCollection size - 1 by: 2 do: [:i | 
		[:prev :parameter :next | |var secondLength |
			next isEmpty 
				ifTrue: [secondLength := runString size]
				ifFalse: [secondLength := (runString findString: next) - 1].
			var := runString copyFrom: prev size + 1 to: secondLength.
			runString := runString allButFirst: prev size + var size.
			result add: parameter  -> var]
		value: (aCollection at: i)
		value: (aCollection at: i + 1)
		value: (aCollection at: i + 2)]	.

	^ result! !

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:06'!
bindParametersInSelector:aSelector toValuesIn: aString

	^ ACTranslator bindParametersInCollection: (self buildSelectorPartsFromString: aSelector) toValuesIn: aString
! !

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:08'!
buildSelectorPartsFromString: aString

	^ Array streamContents: [:stream |	
		"extract the parameters (start with : )"
		(aString findTokens: $:) withIndexDo: [:e :i |
			i ~= 1 
				ifTrue: [ |parameter|
					parameter := e upTo: $ .
					stream 
						nextPut: ':', parameter; "parameter"
						nextPut: (e allButFirst: parameter size)] "rest"
				ifFalse: [stream nextPut: e "start of selector"]]].! !

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:20'!
parameterStringFor: aString

	^ String streamContents: [:stream |
		(aString findTokens: $:) allButFirst do: [:sub |
			stream nextPut: $:;
				nextPutAll: (sub upTo: $ );
				space].
		(aString includes: $:) ifTrue: [stream nextPut: $|]]
! !

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:16'!
replaceParametersWithStarsIn: aString

	^ String streamContents: [:stream | | parts |
		(parts := self buildSelectorPartsFromString: aString)
			withIndexDo: [:part :index | 
				index odd 
					ifTrue: [stream nextPutAll: part]
					ifFalse: [
						(index < parts size) ifTrue: [stream nextPut: $*]]]].! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:27'!
messagePart =

	{symbol:s string:body} -> ['	', s asMutator,' ''', body,'''', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/30/2010 14:27'!
rule =

	{symbol:s string+:bodies} -> [ String streamContents: [:stream | 
			bodies do: [:body | stream nextPutAll: '	self ';  nextPutAll: s asMutator; space; nextPutAll: body printString; nextPut: $.; cr]]]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 11:23'!
scenario =
	
	{symbol:type ?[type = #userStory] title:t messagePart:purpose messagePart:role messagePart:means}
		-> [t, purpose, role, means]
|	{symbol:type ?[type = #scenario] {symbol:ign string:t} rule:given rule:when rule:then}
		-> [t asLegalSelector, self scenarioAnnotation, given, when, then]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:20:38.788'!
scenarioAnnotation

	^ String streamContents: [:stream |
		stream crtab; 	nextPutAll: '<scenario>'; cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 11:58'!
selectorAndStart =

	symbol:tag string:sel -> [(tag, sel asCamelCase, 'Args')  asLegalSelector asString, ': privateArgsCollection',
		String cr, String tab, '<stepTag: ', tag printString, '>',
		String cr, String tab, '<stepMatch: ', (self class replaceParametersWithStarsIn: sel) printString, '>',
		String cr, String tab, '<step: ', sel printString, '>', String cr, '[', (self class parameterStringFor: sel), String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 11:58'!
stepDefinition =

	{selectorAndStart:start string:body} -> [start,  body, String cr, '] valueWithPossibleArgs: privateArgsCollection.', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:35'!
title =

	{symbol:t string:s} -> ['ACUserStory named: ', s asLegalSelector capitalized asSymbol printString, String cr]! !

TestRunner subclass: #ACTestRunner
	instanceVariableNames: 'scenariosSelected scenarios scenarioIndex stepSelected stepIndex stepColors showUserStory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-GUI'!

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 02:36'!
open
	^ ACMorphicToolBuilder new open: self new.! !

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'db 7/19/2010 16:59'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( ACTestRunner build 'Scenario Runner' 'A production scale test-runner.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'db 7/20/2010 14:26'!
registerInWorldMenu

	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'Scenario Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!ACTestRunner class methodsFor: 'as yet unclassified' stamp: 'db 7/19/2010 16:53'!
windowColorSpecification

	^ WindowColorSpec 
		classSymbol: self name 
		wording: 'Accept It Scenario Runner' 
		brightColor:  Color blue
		pastelColor: (Color r: 0.65 g: 0.753 b: 0.976)
		helpMessage: 'Smalltalk TestRunner tool for AcceptIt User Stories'! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/19/2010 15:14'!
baseClass

	^ ACUserStory! !

!ACTestRunner methodsFor: 'utilities' stamp: 'topa 9/22/2010 11:34'!
browseToStepImplementation

	| stepSelector stepLibrary parsedScenario linesWithPrefix sc |
	
	stepIndex < 3 ifTrue:[^nil]."no browsing for title and empty line"
	
	sc := (scenarios at: scenarioIndex).
	parsedScenario := ACUSParser matchAll: (( sc class methodDict at: sc selector) getSource) readStream with: #scenarioForRunner withArgs: #().
	
	linesWithPrefix := OrderedCollection new.
	
	parsedScenario do: [:arr | 
		arr do: [:item | 
			item isSymbol ifFalse:[linesWithPrefix add: {arr at: 1. item}]]]. 
	
	stepSelector := ACUserStory 
		selectorForString: ((linesWithPrefix at: stepIndex - 2) at: 2) asString 
			prefixed: ((linesWithPrefix at: stepIndex - 2) at: 1).
	
	stepLibrary := (scenarios at: scenarioIndex) findLibraryForSelector: stepSelector ifNone: [self alert: 'Not implemented yet'].
	
	Browser newOnClass: stepLibrary class selector: stepSelector.
	
		

! !

!ACTestRunner methodsFor: 'building' stamp: 'db 7/20/2010 01:30'!
buildScenariosWith: aBuilder

	^ aBuilder pluggableMultiSelectionListSpec new
		model: self;
		list: #scenarioList;
		menu: #scenarioMenu:;
		getIndex: #scenarioSelected;
		setIndex: #scenarioSelected:;
		getSelectionList: #scenarioAt:;
		setSelectionList: #scenarioAt:put:;
		yourself.! !

!ACTestRunner methodsFor: 'building' stamp: 'db 7/24/2010 16:36'!
buildStepsWith: aBuilder

	^ aBuilder pluggableACListSpec new
		model: self;
		list: #stepList;
		menu: #stepMenu:;
		getIndex: #stepSelected;
		setIndex: #stepSelected:;
		getListItemColor: #stepColorAt:;
		doubleClick: #browseToStepImplementation
		yourself.! !

!ACTestRunner methodsFor: 'building' stamp: 'db 7/20/2010 02:38'!
buildWith: aBuilder

	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildClassesWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 0.25 @ 0.92 );
				yourself);
			add: ((self buildScenariosWith: aBuilder)
				frame: (0.25 @ 0.00 corner: 0.50 @ 0.92 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildStepsWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: (0.50 @ 0.50 corner: 1.00 @ 0.71);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (0.50 @ 0.71 corner: 1.00 @ 0.92);
				yourself);
			add: ((self buildButtonsWith: aBuilder)
				frame: (0.00 @ 0.92 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		yourself.
	^ aBuilder build: window.! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/21/2010 16:10'!
changed: aSymbol

	Transcript show: aSymbol; cr.
	super changed: aSymbol.
	! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 17:39'!
classAt: anInteger put: aBoolean
	classesSelected := classesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (classes at: anInteger ifAbsent: [^ self ]).
		self updateScenarios.
	self changed: #classSelected; changed: #updateScenarios; changed: #hasRunnable.! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 17:18'!
classSelected: anInteger
	
	classIndex := anInteger.
	showUserStory := true.
	
	self changed: #classSelected; changed: #stepList. "; changed: #updateScenarios ."
	! !

!ACTestRunner methodsFor: 'utilities' stamp: 'db 7/21/2010 15:56'!
findClassesForCategories: aCollection

	aCollection isEmpty 
		ifTrue: [ ^ self baseClass subclasses asSet ].
	! !

!ACTestRunner methodsFor: 'utilities' stamp: 'db 7/21/2010 19:32'!
findScenariosForClasses: aCollection

	| items |
	aCollection isEmpty 
		ifTrue: [  ^{}].
	items := aCollection inject: Set new into: [ :set :class | 
		class allTestSelectors do: [:selector | set add: (class selector: selector)].
		set].
	^ items.! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/21/2010 15:33'!
initialize

	super initialize.
	showUserStory:= true.! !

!ACTestRunner methodsFor: 'accessing-ui' stamp: 'db 7/19/2010 18:29'!
label

	^ 'Accept It Scenario Runner'! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/20/2010 01:31'!
scenarioAt: anIndex

	^ scenariosSelected includes: (scenarios at: anIndex ifAbsent: [ ^ false ]).! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 19:33'!
scenarioAt: anInteger put: aBoolean

	scenariosSelected := scenariosSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (scenarios at: anInteger ifAbsent: [ ^ self ]).
			
	self updateSteps.! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 17:08'!
scenarioList

	^ scenarios! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/20/2010 01:31'!
scenarioMenu: aMenu

	^ aMenu
		title: 'Scenarios'.
		"add: 'Select all' action: #selectAllCategories;
		add: 'Select inversion' action: #selectInverseCategories;
		add: 'Select none' action: #selectNoCategories;
		addLine;
		add: 'Filter...' action: #filterCategories;
		addLine;
		add: 'Refresh' action: #updateCategories;
		yourself."! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/20/2010 01:31'!
scenarioSelected

	^ scenarioIndex! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 15:21'!
scenarioSelected: anInteger

	scenarioIndex := anInteger.
	showUserStory := false.
	self changed: #scenarioSelected.! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/24/2010 16:57'!
stepColorAt: anIndex
	
	^ anIndex = 1
		ifTrue:[ Color blue ]
		ifFalse:[ Color black ].
	! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 16:47'!
stepList

	showUserStory 
		ifTrue:[ (classIndex = 0) ifTrue: [^{}] ifFalse:[^ (classes at: classIndex) userStoryString lines]]
		ifFalse:[
			^ scenarioIndex = 0
				ifTrue:[{}]
				ifFalse:[ |sc|
					sc := (scenarios at: scenarioIndex).
					(sc class methodDict at: sc selector) getSource asString lines]]
		
	
			
	
! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/24/2010 16:23'!
stepSelected
	
	^ stepIndex = nil 
		ifTrue:[ 0 ]
		ifFalse:[ stepIndex ]! !

!ACTestRunner methodsFor: 'accessing' stamp: 'db 7/21/2010 00:56'!
stepSelected: anInteger

	stepIndex := anInteger.
	self changed: #stepSelected.! !

!ACTestRunner methodsFor: 'building' stamp: 'db 7/21/2010 19:35'!
suiteAll
	^ TestSuite new in: [ :suite |
			suite addTests: scenariosSelected.
			suite name: (self label: 'Test' forSuite: suite) ].! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/20/2010 03:02'!
update

	super update.
	self updateScenarios; updateSteps! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/21/2010 16:09'!
update: aSymbol

	Transcript show: aSymbol; cr.
	super update: aSymbol.
	! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/21/2010 17:40'!
updateScenarios

	| scenariosForClasses |
	scenariosForClasses := self findScenariosForClasses: classesSelected.
	scenarios := scenariosForClasses asArray
		sort: [ :a :b | a printString <= b printString ].
	scenarioIndex := 0.
	scenariosSelected := scenariosSelected isNil
		ifTrue: [ scenariosForClasses ]
		ifFalse: [ 
			scenariosSelected
				select: [ :each | scenariosForClasses includes: each ] ].
	self changed: #scenarioList; changed: #scenarioSelected; changed: #hasRunnable.
! !

!ACTestRunner methodsFor: 'updating' stamp: 'db 7/20/2010 14:27'!
updateSteps

	self changed: #stepList


	! !

Compiler subclass: #ACCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACCompiler methodsFor: 'public access' stamp: 'topa 5/19/2010 12:18'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls notifying: notify ifFail: failBlock! !

!ACCompiler methodsFor: 'public access' stamp: 'topa 9/22/2010 11:23'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	| origCodeStream translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[ | parseTree |
			
		parseTree := self parserClass matchStream: origCodeStream with: #scenario withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #scenario.
	] on: OM2Fail do: [:ignore |
		self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value
	].
	^ Compiler new
		compile: translatedCode readStream
		in: cls
		classified: '-- scenarios --'
		notifying: notify
		ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 11:24'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: aStream with: #scenario withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #scenario.
		Parser new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [aBlock value]! !

!ACCompiler methodsFor: 'public access' stamp: 'topa 9/22/2010 11:28'!
parserClass

	^ ACUSParser! !

Compiler subclass: #ACLibraryCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACLibraryCompiler class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 10:30'!
new
	
	" avoid pre-poulation of parser 
	^ self basicNew initialize"
	^ super new! !

!ACLibraryCompiler class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 12:08'!
parserClass

	
	"^ ACSDParser"
	^ super parserClass! !

!ACLibraryCompiler methodsFor: 'public access' stamp: 'topa 8/5/2010 16:07'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	| origCodeStream translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[ | parseTree |
		parseTree := self parserClass matchStream: origCodeStream with: #stepDefinition withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator matchAll: parseTree with: #stepDefinition.
	] on: OM2Fail do: [:ignore |
		"self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value"
	^ Compiler new
		compile: origCodeStream reset
		in: cls
		classified: aCategory
		notifying: notify
		ifFail: failBlock
	].
	^ Compiler new
		compile: translatedCode readStream
		in: cls
		classified: aCategory
		notifying: notify
		ifFail: failBlock! !

!ACLibraryCompiler methodsFor: 'public access' stamp: 'topa 8/5/2010 15:55'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls 	classified: 'as yet unclassified' notifying: notify 	ifFail: failBlock! !

!ACLibraryCompiler methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 10:45'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: aStream with: #stepDefinition withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #stepDefinition.
		super parserClass new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [:failure |
		^ super parserClass new parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock]! !

!ACLibraryCompiler methodsFor: 'public access' stamp: 'topa 9/22/2010 12:08'!
parse: textOrStream in: aClass notifying: req

	| stream |
	stream := textOrStream isStream ifTrue: [textOrStream] ifFalse: [textOrStream asString readStream].
	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: stream with: #stepDefinition withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #stepDefinition.
		super parse: translatedCode readStream in: aClass notifying: req.
	] on: OM2Fail do: [:failure |
		^ super parse: stream reset in: aClass notifying: req]! !

!ACLibraryCompiler methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 12:01'!
parserClass

	^ ACSDParser! !

TestCase subclass: #ACArgumentParsingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACArgumentParsingTest methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:00'!
testArgumentParsing

	|body selectorString variableAssociations|

	body:= 'see potatoe on the 2. screen fert'.
	selectorString:= 'see :thing on the :number screen :name'.

	variableAssociations := ACTranslator bindParametersInSelector: selectorString toValuesIn: body.

	self should: [variableAssociations  = {':thing'->'potatoe' . ':number'->'2.'. ':name'->'fert'} asOrderedCollection]. ! !

!ACArgumentParsingTest methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:00'!
testArgumentParsingWithASingleArgument

	|body selectorString variableAssociations|

	body:= 'see Hello World'.
	selectorString:= 'see :aString'.

	variableAssociations := ACTranslator bindParametersInSelector: selectorString toValuesIn: body.

	self should: [variableAssociations  = {':aString' -> 'Hello World'} asOrderedCollection].! !

!ACArgumentParsingTest methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:01'!
testArgumentParsingWithSpecialCharacters

	|body selectorString variableAssociations|

	body:= 'see potat:oe on the 2 . screen frt'.
	selectorString:= 'see :thing on the :number screen :name'.

	variableAssociations := ACTranslator bindParametersInSelector: selectorString toValuesIn: body.
	
	self should: [variableAssociations  = {':thing'->'potat:oe' . ':number'->'2 .'. ':name'->'frt'} asOrderedCollection]. ! !

!ACArgumentParsingTest methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:01'!
testArgumentParsingWithoutArguments

	|body selectorString variableAssociations|

	body:= 'nothing happens'.
	selectorString:= 'nothing happens'.

	variableAssociations := ACTranslator bindParametersInSelector: selectorString toValuesIn: body.

	self should: [variableAssociations  = (OrderedCollection new)]. ! !

TestCase subclass: #ACCompilerScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:47:47.591'!
testScenarioCompilation

	|scenario acMethod stMethod scenarioDecompiled |
	scenario := 'hello
		Given I have a web site
		When I go to the web site
		Then I see "Hello World"'.
	
	scenarioDecompiled := 'hello
		<scenario>
		self given: ''I have a web site''.
		self when: ''I go to the web site''.
		self then: ''I see "Hello World"''.'.
	
	acMethod := ACCompiler new compile:  scenario  in: self class classified: nil notifying: nil ifFail: [].
	stMethod := Compiler new compile: scenarioDecompiled in: self class classified: nil notifying: nil ifFail: [].
	self 
		should: [acMethod selector = stMethod selector];
		should: [acMethod decompileString = stMethod decompileString].! !

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 16:33:35.829'!
testScenarioHasCorrectName

	|scenario acMethod |
	scenario := 'Here should be the name of the method
		Given I have a web site
		When I go to the web site
		Then I see "Hello World"'.
		
	acMethod := ACCompiler new compile:  scenario  in: self class classified: nil notifying: nil ifFail: [].
	
	self 
		should: [acMethod selector =  'hereshouldbethenameofthemethod'].
		 ! !

TestCase subclass: #ACCompilerUserStoryTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:07'!
directClassWithVariablesSet

	| theKlass |
	theKlass := (ACUserStory subclass: self klassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: ACUserStory category).
	^ theKlass purpose: 'impress the ladies'; role: 'Casanova'; means: 'Prosecco'.! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName

	^ klassName! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName: anObject

	klassName := anObject! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 9/22/2010 11:30'!
parseTree

	^ ACTranslator match: (ACUSParser matchStream: 
'A Name For Testing
In order to impress the ladies
As a Casanova
I want Prosecco
' readStream with: #userStory withArgs: #() withPlaybackDebugging: false) with: #scenario! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:08'!
removeTestClass

	self klassName ifNotNilDo: [:name | 
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 13:57'!
setUp

	self klassName: #ANameForTesting.! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 14:02'!
tearDown

	self removeTestClass.! !

!ACCompilerUserStoryTest methodsFor: 'testing' stamp: 'fg 6/11/2010 14:16:34.89'!
testUserStoryCompilation

	| direct indirect generated |
	direct := self directClassWithVariablesSet definition.
	self removeTestClass.
	indirect := (ACUserStory named: self klassName
		purpose: 'impress the ladies' 
		role: 'Casanova'
		means: 'Prosecco') definition.
	self removeTestClass.
	generated := (Compiler evaluate: self parseTree notifying: nil logged: false) definition.
	self removeTestClass.
	
	self 
		should: [direct = indirect];
		should: [indirect = generated].! !

TestCase subclass: #ACDeltaFunctionTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:28'!
klassName

	^klassName! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:28'!
klassName: anObject

	klassName := anObject! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:29'!
removeTestClass: clsName

	clsName ifNotNilDo: [:name |
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:19'!
setUp

	super setUp.
	self klassName: #ACMyTestClass.
	"ensure its not there"
	self removeTestClass: self klassName.
! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:20'!
tearDown

	self removeTestClass: self klassName.
	super tearDown.! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'topa 7/8/2010 15:07'!
testWithHaveAsString
	"comment stating purpose of message"
	
	|testString expectedString |
	testString := 'have a WebSite'.
	expectedString := 'has a WebSite'.
	self assert:  (testString withLeadingAuxiliaryNormalized) = expectedString.! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'topa 7/8/2010 15:09'!
testWithIAndHaveAsSelector
	"comment stating purpose of message"
	
	|testString expectedString |
	testString := 'I have a WebSite'.
	expectedString := 'has a WebSite'.
	
	self assert:  (testString withoutLeadingSubject withLeadingAuxiliaryNormalized) = expectedString.! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/21/2010 01:22'!
testWithIAndShouldAsSelector
	
	| userStory testString expectedSymbol |
	userStory := ('AC My Test Class
		In order to deal with UserStories
		As a developer
		I want generated classes from Userstories' as: ACUserStory) new.

	testString := 'I should have four cars in stock'.
	expectedSymbol := #givenShouldHaveFourCarsInStock.
	
	self assert: (userStory class selectorForString: testString prefixed: #given) = expectedSymbol.
	! !

TestCase subclass: #ACParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

ACParserTest subclass: #ACParserScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserScenarioTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:32'!
parserClassToTest

	^ ACUSParser! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:09'!
testScenarioAnd

	|and|
	and:= 'And I have a web site'.
	self should: [self match: and with: #and].	! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:10'!
testScenarioGiven

	|given|
	given:= 'Given I have a web site'.

	self should: [self match: given with: #given].! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:11'!
testScenarioGivenAnd

	|given|
	given:= 
'Given I have a web site
And I am not logged in'.

	self should: [self match: given with: #applyLines withArgs: #(given)].	! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:35:50.72'!
testScenarioInvalidNewlinesMatch

|scenarioInvalidNewlines|
	
	scenarioInvalidNewlines := 'Given I have a web site
	
		When I go to the web site
		
		Then I see "Hello World"'.
	self shouldnt: [self match:  scenarioInvalidNewlines with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:03.478'!
testScenarioInvalidOrderMatch

|scenarioInvalidOrder|

	scenarioInvalidOrder:= 'When I go to the web site
		Given I have a web site
		Then I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidOrder with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:51.013'!
testScenarioInvalidSyntaxMatch
|scenarioInvalidSyntax|

	scenarioInvalidSyntax:= 'Gvien I have a web site
		Wehn I go to the web site
		Tehn I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidSyntax with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:13:37.893'!
testScenarioInvalidTrailersMatch

|scenarioInvalidTrailers|
scenarioInvalidTrailers:= 'Given I have a web site
	When I go to the web site
	Then I see "Hello World"
	Yes, This would be awesome.'.
	
	self shouldnt: [self match: scenarioInvalidTrailers with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 6/30/2010 13:10'!
testScenarioMatch

	|scenario|
	scenario:= 'Hello World
	Given I have a web site
	When I go to the web site
	Then I see "Hello World"'.
	self should: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 6/30/2010 13:11'!
testScenarioMatchAnd
	
	|scenario|
	scenario:= 'Hello World
	Given I have a web site
	And I am not logged in
	When I go to the web site
	And I click "Login"
	Then I see "Hello"
	And I see "World"'.
	self should: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/15/2010 16:30:43.661'!
testScenarioMissingName
|scenario|

	scenario:= '	Given I have a web site
	When I go to the web site
	Then I see "Hello World"'.
	self shouldnt: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:13'!
testScenarioThen
	
	|then|
	then := 'Then I see "Hello World"'.
	
	self should: [self match: then with: #then].	! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:14'!
testScenarioThenAnd
	
	|then|
	then := 
'Then I see "Hello"
And I see "World"'.
	
	self should: [self match: then with: #applyLines withArgs: #(then)].! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:14'!
testScenarioWhen

	|when|
	when:= 'When I go to the web site'.
	self should: [self match: when with: #when].! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:15'!
testScenarioWhenAnd

	|when|
	when:= 
'When I go to the web site
And I click "Login"'.

	self should: [self match: when with: #applyLines withArgs: #(when)].! !

ACParserTest subclass: #ACParserStepdefTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserStepdefTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:32'!
parserClassToTest

	^ ACSDParser! !

!ACParserStepdefTest methodsFor: 'tests' stamp: 'topa 8/5/2010 11:05'!
testStepdefMatch

	|stepdef|
	stepdef:= 
	'(given) is a User
	^ self.'.
	
	self should: [self match: stepdef with: #stepDefinition].
! !

!ACParserStepdefTest methodsFor: 'tests' stamp: 'topa 8/31/2010 03:22'!
testStepdefMatchArg

	|stepdef|
	stepdef:= 
	'(given) has :number opportunities
	^ self.'.
	
	self should: [self match: stepdef with: #stepDefinition].
! !

!ACParserStepdefTest methodsFor: 'tests' stamp: 'topa 9/22/2010 11:56'!
testStepdefMatchArgPt

	|stepdef pt|
	stepdef:= 
	'(given) has :number opportunities
	^ self.'.
	pt := #(#given 'has :number opportunities' '	^ self.').
	
	self should: [(ACSDParser matchAll: stepdef with: #stepDefinition) = pt].
! !

!ACParserStepdefTest methodsFor: 'tests' stamp: 'topa 9/22/2010 11:56'!
testStepdefMatchPt

	|stepdef pt|
	stepdef:= 
	'(given) is a User
	^ self.'.
	pt := #(#given 'is a User' '	^ self.').
	
	self should: [(ACSDParser matchAll: stepdef with: #stepDefinition) = pt].
! !

!ACParserTest class methodsFor: 'as yet unclassified' stamp: 'topa 5/27/2010 14:50'!
isAbstract

	^ self == ACParserTest! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 6/30/2010 14:12'!
match: aString with: aRule

	^ self match: aString with: aRule withArgs: #()
! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:31'!
match: aString with: aRule withArgs: args

	[self parserClassToTest matchAll: aString with: aRule withArgs: args]
		on: OM2Fail
		do: [^ false].
	^ true! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:31'!
parserClassToTest

	self subclassResponsibility! !

ACParserTest subclass: #ACParserUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserUserStoryTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:31'!
parserClassToTest

	^ ACUSParser! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:36:39.815'!
testUserStoryInvalidNewlinesMatch

	|userStoryInvalidNewlines|
	userStoryInvalidNewlines :='A Title
		In order to achieve something
		
		As a role
		
		I want to do something.'.
	self shouldnt: [self match: userStoryInvalidNewlines with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:18:37.474'!
testUserStoryInvalidOrderMatch

	|userStoryInvalidOrder|
	userStoryInvalidOrder := 'A Title
		As a role
		I want to do something
		In order to achieve something.'.
	self shouldnt: [self match: userStoryInvalidOrder with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:19:35.46'!
testUserStoryInvalidSyntaxMatch

	|userStoryInvalidSyntax|
	userStoryInvalidSyntax := 'A Title
		In roder to achieve something
		Asa role
		I wnat ot do something.'.
	self shouldnt: [self match: userStoryInvalidSyntax with: #userStory].
	self flag: #extend. "topa: should look for position of invalid syntax"! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:20:19.864'!
testUserStoryInvalidTrailersMatch

	|userStoryInvalidTrailers|
	userStoryInvalidTrailers := 'A Title
		In order to achieve something
		As a role
		I want to do something.
	
		This is cool
		'.
	self shouldnt: [self match: userStoryInvalidTrailers with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:21:18.908'!
testUserStoryMatch

	|userStory|
	userStory := 'A Title
		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match: userStory with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:22:37.873'!
testUserStoryMeansMatch

	|means|
	means:= 'I want to do something.'.
	self should: [self match: means with: #meansLine].	! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:23:49.879'!
testUserStoryMeansOptionalToMatch

	|meansOptionalTo|
	meansOptionalTo := 'I want a cake.'.
	self should: [  self match: meansOptionalTo with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:24:39.316'!
testUserStoryMeansOptionalToWithAnMatch

|meansOptionalToWithAn|
	meansOptionalToWithAn :='I want an embedded sleeping hour.'.
	self should: [  self match: meansOptionalToWithAn with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:26:24.557'!
testUserStoryMissingArgsMatch

	|userStoryMissingArgs|
	userStoryMissingArgs := 'A Title
		In order to
		As a
		I want'.
	self shouldnt: [self match: userStoryMissingArgs with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:27:38.785'!
testUserStoryNewlineAfterTitleMatch
	
	|userStoryNewlineAfterTitle|
	userStoryNewlineAfterTitle := 'A Title

		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match:  userStoryNewlineAfterTitle with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:28:44.094'!
testUserStoryPurposeMatch

	|purpose|
	purpose := 'In order to achieve something.'.
	self should: [  self match: purpose with: #purposeLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:29:30.091'!
testUserStoryRoleMatch

	|role|
	role :=  'As a role'.
	self should: [ self match: role with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:09.156'!
testUserStoryRoleWithAnMatch

	|roleWithAn|
	roleWithAn := 'As an emancipated role'.
	self should: [ self match: roleWithAn with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:47.067'!
testUserStoryRoleWithPluralMatch
	
	|roleWithPlural|
	roleWithPlural:='As roles'.
	self shouldnt: [ self match: roleWithPlural with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:31:33.05'!
testUserStorySpacingMatch
	
	|userStorySpacing|
	userStorySpacing := 
	'A Title
	    In order to achieve something
		As a role
	 	 I want to do something.'.
	self should: [self match: userStorySpacing with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/19/2010 12:22'!
testUserStoryTitleMatch

	self should: [self match: 'A Title' with: #title].	! !

TestCase subclass: #ACTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:29'!
testGivenMultiTranslation

	|pt sourceCode|
	
	pt:= #(given 'I have a web site' 'I am not logged in').
	sourceCode:= '	self given: ''I have a web site''.', String cr, '	self given: ''I am not logged in''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testGivenTranslation

	|pt sourceCode|
	
	pt:= #(given 'I have a web site').
	sourceCode:= '	self given: ''I have a web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:39'!
testMeansTranslation

	| pt |
	pt:= #(means 'do something.').
	self should: (ACTranslator match: pt with: #messagePart) = ('	means: ''do something.''', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:40'!
testPurposeTranslation

	| pt |
	pt:= #(purpose 'achieve something').
	self should: (ACTranslator match: pt with: #messagePart) = ('	purpose: ''achieve something''', String cr).
	! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:41'!
testRoleTranslation

	| pt |
	pt:= #(role 'role').
	self should: (ACTranslator match: pt with: #messagePart) = ('	role: ''role''', String cr).! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 9/22/2010 11:24'!
testScenarioMultiTranslation

	|pt sourceCode |
	
	
	pt:=#(#scenario 
			#(#title 'hello')
			#(#given 'I have a web site' 'I am not logged in')
			#(#when 'I go to the web site' 'I click "Login"')
			#(#then 'I see "Hello"' 'I see "World"')).		
	sourceCode:= 'hello
	<scenario>
	self given: ''I have a web site''.
	self given: ''I am not logged in''.
	self when: ''I go to the web site''.
	self when: ''I click "Login"''.
	self then: ''I see "Hello"''.
	self then: ''I see "World"''.', String cr.
	self should: (ACTranslator match: pt with: #scenario) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 9/22/2010 11:24'!
testScenarioTranslation

	|pt sourceCode |
	
	
	pt:=#(#scenario 
			#(#title 'hello')
			#(#given 'I have a web site')
			#(#when 'I go to the web site')
			#(#then 'I see "Hello World"')).		
	sourceCode:= 'hello
	<scenario>
	self given: ''I have a web site''.
	self when: ''I go to the web site''.
	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #scenario) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-stepdef' stamp: 'topa 9/22/2010 11:57'!
testStepDefMatch

	|pt source|
	pt := #(#given 'is a User' '	^ self.').
	source := 
	'givenIsAUserArgs: privateArgsCollection
	<stepTag: #given>
	<stepMatch: ''is a User''>
	<step: ''is a User''>
[
	^ self.
] valueWithPossibleArgs: privateArgsCollection.
'.
	
	self should: [ (ACTranslator match: pt with: #stepDefinition) = source].! !

!ACTranslatorTest methodsFor: 'tests-stepdef' stamp: 'topa 9/22/2010 11:57'!
testStepDefMatchArg

	|pt source|
	pt := #(#given 'has :number opportunities' '	^ self.').
	source := 
	'givenHasnumberOpportunitiesArgs: privateArgsCollection
	<stepTag: #given>
	<stepMatch: ''has * opportunities''>
	<step: ''has :number opportunities''>
[:number |
	^ self.
] valueWithPossibleArgs: privateArgsCollection.
'.
	
	self should: [ (ACTranslator match: pt with: #stepDefinition) = source].! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:29'!
testThenMultiTranslation

	|pt sourceCode|
	
	pt:= #(then 'I see "Hello"' 'I see "World"').
	sourceCode:= '	self then: ''I see "Hello"''.', String cr,'	self then: ''I see "World"''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:45'!
testThenTranslation

	|pt sourceCode|
	
	pt:= #(then 'I see "Hello World"').
	sourceCode:= '	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:42'!
testTitleTranslation

	| pt |
	pt:= #(title 'A Title').
	self should: (ACTranslator match: pt with: #title) = ('ACUserStory named: #ATitle', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 9/22/2010 11:24'!
testUserStoryTranslation

	| pt source |
	pt:= #(userStory
		#(title 'A Title') 
		#(purpose 'achieve something') 
		#(role 'role') 
		#(means 'do something.')).
	source := 'ACUserStory named: #ATitle
	purpose: ''achieve something''
	role: ''role''
	means: ''do something.''
'.
	self should: (ACTranslator match: pt with: #scenario) = source.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:29'!
testWhenMultiTranslation

	|pt sourceCode|
	
	pt:= #(when 'I go to the web site' 'I log in').
	sourceCode:= '	self when: ''I go to the web site''.', String cr,'	self when: ''I log in''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testWhenTranslation

	|pt sourceCode|
	
	pt:= #(when 'I go to the web site').
	sourceCode:= '	self when: ''I go to the web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

TestCase subclass: #ACUserStory
	instanceVariableNames: 'stepLibraries configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

ACUserStory class
	instanceVariableNames: 'purpose role means userStoryString'!

ACUserStory class
	instanceVariableNames: 'purpose role means userStoryString'!

!ACUserStory class methodsFor: 'accessing' stamp: 'fg 6/30/2010 16:22'!
allTestSelectors

	^ (Pragma allNamed: #scenario in: self)
			collect: [:pragma | pragma selector]
! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 14:37'!
buildArgumentsForMethod: aMethod using: aString

	| selector |
	selector :=  (aMethod pragmas detect: [:pragma | pragma keyword = #step:]) arguments first.
	^ (ACTranslator 
		bindParametersInSelector: selector 
		toValuesIn: aString withoutLeadingSubject withLeadingAuxiliaryNormalized)
		collect: [:assoc | assoc value]! !

!ACUserStory class methodsFor: 'configuration' stamp: 'topa 7/14/2010 12:47'!
buildConfiguration: aDictionary

	"to be used in UserStories to override Libraries defaults"! !

!ACUserStory class methodsFor: 'accessing method dictionary' stamp: 'topa 9/22/2010 13:57'!
compiledMethodAt: selector ifAbsent: aBlock

	| key |
	key := selector asSymbol.
	^ self scenarioAndMethodDict
		at: key
		ifAbsent: [super compiledMethodAt: key ifAbsent: aBlock]! !

!ACUserStory class methodsFor: 'compiling' stamp: 'topa 6/14/2010 12:41'!
compilerClass
		
	^ self looksLikeUserStoryHeir
		ifTrue: [	ACCompiler]
		ifFalse: [super compilerClass]
! !

!ACUserStory class methodsFor: 'fileIn/Out' stamp: 'topa 6/29/2010 15:13'!
definition

	^ self == ACUserStory
		ifTrue: [super definition]
		ifFalse: [String streamContents: [:stream |
			stream
				nextPutAll: self userStoryString printString;  crtab;
				nextPutAll: 'as: ';
				nextPutAll: (super definition findTokens: ' ') first]]
				
"				nextPutAll: (super definition findTokens: ' ') first; space;
				nextPutAll: 'named: '; nextPutAll: self name printString; crtab;
				nextPutAll: 'purpose: '; nextPutAll: self purpose printString; crtab;
				nextPutAll: 'role: '; nextPutAll: self role printString; crtab;
				nextPutAll: 'means: '; nextPutAll: self means printString"! !

!ACUserStory class methodsFor: 'testing' stamp: 'topa 6/3/2010 13:23'!
isAbstract

	^ self == ACUserStory! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/1/2010 14:20'!
libraries

	^ #()! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/14/2010 12:46'!
looksLikeUserStoryHeir
	"During recompilation of the ACUserStory class, all of
	#==, #inheritsFrom:, or #isKindOf: will fail, so we have to rely
	on the name of the class and walk the superclasses ourselves"
	
	self allSuperclassesDo: [:cls |
		cls name = #ACUserStory
			ifTrue: [^ true]].
	^ false! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means

	^means! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means: anObject

	means := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 12:48'!
named: aNameSymbol
purpose: purposeString
role: roleString
means: meansString

	|klass|		
	klass := self subclass: aNameSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.
	klass purpose: purposeString; role: roleString; means: meansString.
	
	^ klass! !

!ACUserStory class methodsFor: 'instance creation' stamp: 'topa 6/8/2010 14:03'!
newFrom: anObject

	(anObject isKindOf: String)
		ifTrue: [^ self userStoryFromString: anObject].

	^ super newFrom: anObject! !

!ACUserStory class methodsFor: 'organization' stamp: 'topa 9/22/2010 13:52'!
organization
	
	true 
	ifFalse: [^super organization]
	ifTrue: [
	organization ifNil: [|list|
		self organization: (UserStoryOrganizer defaultList:  self scenarioAndMethodDict keys sort)].

	"Making sure that subject is set correctly. It should not be necessary."
	organization setSubject: self.
	^ organization].! !

!ACUserStory class methodsFor: 'compiling' stamp: 'topa 9/22/2010 11:44'!
parserClass

	self name = #ACUserStory
		ifFalse: [
			" this is only necessary to avoid a (inapplicable) warning from the Browser"
			 "((thisContext client isKindOf: Browser) and: [
				(thisContext sender selector = #validateMessageSource:forSelector:) or:  [
				thisContext sender selector =	#validateMessageSource:forSelector:inClass: ]])
					ifTrue: [^ACUSParser]"
			^ ACUSParser].
	^ super parserClass
! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose

	^purpose! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose: anObject

	purpose := anObject! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role

	^role! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role: anObject

	role := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 13:52'!
scenarioAndMethodDict

	"1 halt."
	^ self methodDict inject: MethodDictionary new into: [:md :cMeth | 
		(cMeth pragmaAt: #scenario)
			ifNil: ["normal method" md at: cMeth selector put: cMeth; yourself]
			ifNotNil: [md at: cMeth getSource asString lines first asSymbol put: cMeth; yourself]].! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 8/5/2010 11:54'!
selectorForString: aString prefixed: aSymbol

	^ (aSymbol, 
		aString 
			withoutLeadingSubject 
			withLeadingAuxiliaryNormalized 
			asCamelCase)  asLegalSelector asSymbol! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:58'!
setUpUserStory

	"nothing. to be used for UserStory specific set up"! !

!ACUserStory class methodsFor: 'ShoutCore-Parsing' stamp: 'topa 9/22/2010 11:35'!
shoutParserClass

	^ (self inheritsFrom: ACUserStory)
		ifTrue: [ACUSParser]
		ifFalse: [super shoutParserClass]! !

!ACUserStory class methodsFor: 'accessing method dictionary' stamp: 'topa 9/22/2010 14:02'!
sourceCodeAt: selector ifAbsent: aBlock

	| cMeth |
	cMeth := self scenarioAndMethodDict at: selector asSymbol ifAbsent: [^ aBlock value].
	^ cMeth getSourceFor: cMeth selector in: self! !

!ACUserStory class methodsFor: 'compiling' stamp: 'topa 7/15/2010 10:37'!
sourceCodeTemplate
	
	^ self looksLikeUserStoryHeir 
		ifTrue: [
'Name of scenario

Given some preconditions
And another preconditition
When a certain event is triggered
And another "action" is invoked
Then a criterion holds
And a second criterion should be valid']
		ifFalse: [super sourceCodeTemplate]
! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:58'!
tearDownUserStory

	"nothing. to be used for UserStory specific tear down"! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 11:35'!
userStoryFromString: anObject

	| newClass |
	newClass := (Compiler 
		evaluate: (ACTranslator 
			match: (ACUSParser matchAll: anObject readStream with: #userStory withArgs: #()) 
			with: #scenario)
		notifying: nil 
		logged: true).
	newClass class compile:
	('initialize
	
	super initialize.
	self userStoryString: ', anObject printString, '. ')
	classified: 'initialize-release'.
	^ newClass initialize! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:12'!
userStoryString

	^ userStoryString! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:11'!
userStoryString: aString

	userStoryString := aString.! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/15/2010 09:30'!
configuration

	^ configuration ifNil: [
		self configuration: IdentityDictionary new.
		self stepLibraries do: [:library |
			(library respondsTo: #buildDefaultConfiguration:) ifTrue: [
				library buildDefaultConfiguration: configuration]].
		self class buildConfiguration: configuration.
		configuration].
	! !

!ACUserStory methodsFor: 'accessing' stamp: 'topa 7/14/2010 15:20'!
configuration: anObject

	configuration := anObject! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 04:04'!
defaultTimeout

	"disable"
	^ 600! !

!ACUserStory methodsFor: 'error handling' stamp: 'db 7/21/2010 14:57'!
doesNotUnderstand: aMessage

	^ aMessage sendTo: (self findLibraryForSelector: aMessage selector ifNone:[^ super doesNotUnderstand: aMessage]).
	! !

!ACUserStory methodsFor: 'error handling' stamp: 'db 7/21/2010 15:01'!
findLibraryForSelector: aSelector ifNone: aBlock

	^ self stepLibraries detect: [:lib | lib respondsTo: aSelector]
		ifNone: [aBlock value].
	! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 8/31/2010 07:10'!
given: aString
	
	| method args|
	(method := self mapFromString: aString toStepMethodWithVerb: #given).
	args := self class buildArgumentsForMethod: method using: aString.
	^ method valueWithReceiver: self arguments: {args}! !

!ACUserStory methodsFor: 'initialize-release' stamp: 'topa 7/15/2010 09:31'!
initialize

	super initialize.
	self stepLibraries: OrderedCollection new.
	
	" initialize the delegate libraries"
	self class libraries do: [:library |
		self stepLibraries add: (library newForScenario: self)].! !

!ACUserStory methodsFor: 'running' stamp: 'topa 8/31/2010 04:13'!
mapFromString: aString toStepMethodWithVerb: aSymbol
	
	(self methodsForVerb: aSymbol) do: [:method |
		method pragmas do: [:pragma | 
			((pragma keyword = #stepMatch:) and: 
				[(pragma arguments first) match: aString withoutLeadingSubject withLeadingAuxiliaryNormalized])
				ifTrue: [^ method]]].
	^ self notYetImplemented! !

!ACUserStory methodsFor: 'running' stamp: 'topa 8/31/2010 03:44'!
methodsForVerb: aSymbol

	^ Array streamContents: [:stream |
		self stepLibraries do: [:lib |
			(Pragma allNamed: #stepTag: in: lib class) do: [:pragma |
				(pragma arguments first = aSymbol) 
					ifTrue: [stream nextPut: pragma method]]]]! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/14/2010 11:33'!
runCase
	
	<timeout: 10>

	[super runCase]
	on: NotYetImplemented
	do: [self signalFailure: 'Step not yet implemented']! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/14/2010 15:57'!
setUp

	super setUp.
	self class setUpUserStory.
	(self stepLibraries)
		do: [:library | (library respondsTo: #setUp) ifTrue: [library setUp]];
		do: [:library | (library respondsTo: #setUpUserStory:) ifTrue: [library setUpUserStory: self class name]];
		do: [:library | (library respondsTo: #setUpScenario:) ifTrue: [library setUpScenario: self selector]]		! !

!ACUserStory methodsFor: 'private' stamp: 'topa 7/14/2010 15:20'!
stepLibraries

	^stepLibraries! !

!ACUserStory methodsFor: 'private' stamp: 'topa 7/14/2010 15:20'!
stepLibraries: anObject

	stepLibraries := anObject! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/14/2010 15:57'!
tearDown


	(self stepLibraries)
		do: [:library | (library respondsTo: #tearDownScenario:) ifTrue: [library tearDownScenario: self selector]];
		do: [:library | (library respondsTo: #tearDownUserStory:) ifTrue: [library tearDownUserStory: self class name]];
		do: [:library | (library respondsTo: #tearDown) ifTrue: [library tearDown]].
	self class tearDownUserStory.
	super tearDown.! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 8/31/2010 07:11'!
then: aString

	self assert: [| method args|
	(method := self mapFromString: aString toStepMethodWithVerb: #given).
	args := self class buildArgumentsForMethod: method using: aString.
	method valueWithReceiver: self arguments: {args}].
	! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 8/31/2010 07:10'!
when: aString

	| method args|
	(method := self mapFromString: aString toStepMethodWithVerb: #when).
	args := self class buildArgumentsForMethod: method using: aString.
	^ method valueWithReceiver: self arguments: {args}! !

TestCase subclass: #ACVerticalPrototypeTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACVerticalPrototypeTest methodsFor: 'accessing' stamp: 'topa 6/17/2010 13:16'!
klassName

	^klassName! !

!ACVerticalPrototypeTest methodsFor: 'accessing' stamp: 'topa 6/17/2010 13:16'!
klassName: anObject

	klassName := anObject! !

!ACVerticalPrototypeTest methodsFor: 'helper' stamp: 'fg 6/10/2010 19:57:56.355'!
removeTestClass: clsName

	clsName ifNotNilDo: [:name |
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACVerticalPrototypeTest methodsFor: 'running' stamp: 'topa 6/17/2010 13:18'!
setUp

	super setUp.
	self klassName: #ACMyTestClass.
	"ensure its not there"
	self removeTestClass: self klassName.
! !

!ACVerticalPrototypeTest methodsFor: 'running' stamp: 'topa 6/17/2010 13:18'!
tearDown

	self removeTestClass: self klassName.
	super tearDown.! !

!ACVerticalPrototypeTest methodsFor: 'testing' stamp: 'topa 7/15/2010 15:11'!
testVerticalPrototype
	<timeout: 10>
	| userStory scenario numOfMethods storedMethod |

	userStory := 'AC My Test Class
		In order to deal with UserStories
		As a developer
		I want generated classes from Userstories' as: ACUserStory.
	self 
		should: [userStory inheritsFrom: TestCase];
		should: [userStory name = self klassName].
	
	numOfMethods := userStory methodDict size.
	scenario := userStory compile: 
'Hello World Test
Given I have a web site
When I go to the web site
Then I see "Hello World"'
						 classified: nil.
	self 
		should: [userStory methodDict size = (numOfMethods +1)];
		should: [userStory methodDict includesKey: scenario].
	
	" Configuration "
	userStory class compile: 'libraries ^ {ACVerticalPrototypeLibrary . ACAlbatrossLibrary}'.
	userStory class compile: 'buildConfiguration: aDictionary

	aDictionary 
		at: #albatrossSubjectApplication
			put: (WADispatcher default entryPointAt: ''ACTest'');
		at: #albatrossPort
			put: 9999.'.
	
	"ACTestRootComponent is hard coded in ACVerticalPrototypeTest"
	"generate empty renderContentOn:"
	storedMethod := ACTestRootComponent methodDict at: #renderContentOn: ifAbsent: [self error].
	[ACTestRootComponent methodDict removeKey: #renderContentOn:.
	self should: [(userStory run: scenario) hasFailures].
	] ensure: [ACTestRootComponent methodDict at: #renderContentOn: put: storedMethod].
	
	self should: [(userStory run: scenario)  hasPassed].! !

ClassOrganizer subclass: #UserStoryOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core'!

SHParserST80 subclass: #ACSHParserForLibrary
	instanceVariableNames: 'inScanLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACSHParserForLibrary methodsFor: 'eol-helper' stamp: 'topa 9/22/2010 07:38'!
atEndOfLine


	^ self isEndOfLine: currentTokenFirst! !

!ACSHParserForLibrary methodsFor: 'accessing' stamp: 'topa 8/31/2010 09:37'!
inScanLine
	
	^ inScanLine! !

!ACSHParserForLibrary methodsFor: 'accessing' stamp: 'topa 8/31/2010 09:14'!
inScanLine: aBoolean
	
	inScanLine := aBoolean! !

!ACSHParserForLibrary methodsFor: 'accessing' stamp: 'topa 9/22/2010 12:24'!
initialize

	super initialize.
	self inScanLine: false.! !

!ACSHParserForLibrary methodsFor: 'eol-helper' stamp: 'topa 8/31/2010 09:48'!
isEndOfLine: c

	^ ((c == Character cr)
	or: [c == Character lf])
	or: [c charCode = 12]
! !

!ACSHParserForLibrary methodsFor: 'parse' stamp: 'topa 8/31/2010 08:52'!
parseMessagePattern

	(currentTokenFirst == $( )
		ifTrue: [self scanLine]
		ifFalse: [super parseMessagePattern]! !

!ACSHParserForLibrary methodsFor: 'scan' stamp: 'topa 9/22/2010 07:39'!
scanLine

	self inScanLine: true.
	"(given)"
	bracketDepth := bracketDepth + 1.
	self scanPast: #leftParenthesis level: bracketDepth.
	self parseUnaryMessagePattern.
	self failUnless: currentTokenFirst == $).
	self scanPast: #rightParenthesis level: bracketDepth.
	bracketDepth := bracketDepth - 1.
	
	[self atEndOfLine] whileFalse: [
		self parseUnaryMessagePattern.
		(currentTokenFirst == $:)
			ifTrue: [
				self scanPast: #blockArgColon.
				self failUnless: self isName.
				self scanPast: #blockPatternArg].
	].
	self inScanLine: false.
	self scanNext.! !

!ACSHParserForLibrary methodsFor: 'scan' stamp: 'topa 8/31/2010 09:50'!
scanWhitespace

	| c |
	self inScanLine ifFalse: [^ super scanWhitespace].
	
	[c := self currentChar.
	(c notNil and: [c isSeparator]) and: [(self isEndOfLine: c) not]] 
		whileTrue: [sourcePosition := sourcePosition + 1].
	c == $" ifTrue: [self scanComment]! !
